package com.prank.sounds.fart.activity;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.view.View;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.bumptech.glide.Glide;
import com.prank.sounds.fart.R;
import com.prank.sounds.fart.bean.Info;
import com.prank.sounds.fart.tools.Db;
import com.prank.sounds.fart.tools.MyItemDecoration;
import com.prank.sounds.fart.tools.MyUtils;
import com.prank.sounds.fart.databinding.PlaySoundsActBinding;
import com.prank.sounds.fart.frag.DialogTimer;
import com.prank.sounds.fart.myadapter.AdapterViewAll;
import com.prank.sounds.fart.callback.OnClickSounds;
import com.prank.sounds.fart.callback.OnClickTimer;

import java.io.IOException;
import java.util.List;

public class PlaySoundsAct extends AppCompatActivity implements View.OnClickListener, OnClickTimer, OnClickSounds {

    private PlaySoundsActBinding playBinding;

    private Info info;
    private DialogTimer dialogTimer;

    private MediaPlayer mediaPlayer;
    private BroadcastReceiver volumeReceiver;
    private CountDownTimer countDownTimer;
    private int color;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        playBinding = PlaySoundsActBinding.inflate(getLayoutInflater());
        setContentView(playBinding.getRoot());
        MyUtils.setStatusBarTextColor(this, true);
        info = (Info) getIntent().getSerializableExtra(MyUtils.KEY_PLAY_DATA);
        color =  getIntent().getIntExtra(MyUtils.KEY_LIST_COLOR_POS,0);
//        playBinding.constraintLayout.setBackground(ContextCompat.getDrawable(this, Tools.playBgs[color]));
        initAudio();
        String covert = info.getCovert();
        if (covert != null && !covert.isEmpty()) {
            Glide.with(this).load(covert)
                    .placeholder(R.drawable.icon_default_sounds)
                    .into(playBinding.image);
        } else {
            Glide.with(this).load(R.drawable.icon_default_sounds)
                    .into(playBinding.image);
        }
        playBinding.name.setText(info.getName());
        playBinding.back.setOnClickListener(this);
        playBinding.btnPlay.setOnClickListener(this);
        playBinding.imLike.setOnClickListener(this);
        playBinding.imLoop.setOnClickListener(this);
        playBinding.imTimer.setOnClickListener(this);
        MyUtils.setVolume(this, playBinding.seekbar);

        initLike();
        loadMore();
        volumeReceiver();

    }

    private void stopCountDown() {
        if (countDownTimer != null) {
            countDownTimer.cancel();
        }
    }
    private void startCountDown(long time) {
        stopCountDown();
        countDownTimer = new CountDownTimer(time, 1000) {
            @Override
            public void onTick(long millisUntilFinished) {
            }
            @Override
            public void onFinish() {
                dialogTimer.setOffSelected();
                if (!mediaPlayer.isPlaying()) {
                    playBinding.btnPlay.setSelected(true);
                    mediaPlayer.start();
                }
            }
        };
        countDownTimer.start();
    }
    private void volumeReceiver() {
        volumeReceiver = new BroadcastReceiver() {
            @Override
            public void onReceive(Context context, Intent intent) {
                if (intent.getAction().equals("android.media.VOLUME_CHANGED_ACTION")) {
                    AudioManager audioManager = (AudioManager) context.getSystemService(Context.AUDIO_SERVICE);
                    int currentVolume = audioManager.getStreamVolume(AudioManager.STREAM_MUSIC);
                    if (playBinding.seekbar.getProgress() != currentVolume) {
                        playBinding.seekbar.setProgress(currentVolume);
                    }

                }
            }
        };
        IntentFilter filter = new IntentFilter("android.media.VOLUME_CHANGED_ACTION");
        registerReceiver(volumeReceiver, filter);
    }
    private void initLike() {
        boolean b = Db.checkLike(info);
        playBinding.imLike.setSelected(b);
    }
    private void loadMore() {
        List<Info> more = Db.getMore();
        MyItemDecoration itemHelper = new MyItemDecoration(0, 0, (int) MyUtils.dpToPx(3));
        AdapterViewAll adapterViewAll = new AdapterViewAll(this, more, 1, this);
        playBinding.moreRecycler.setLayoutManager(new LinearLayoutManager(this, LinearLayoutManager.HORIZONTAL, false));
        playBinding.moreRecycler.setAdapter(adapterViewAll);
        playBinding.moreRecycler.addItemDecoration(itemHelper);
        adapterViewAll.setColorIndex(color);
    }

    private void initAudio() {
        showPlayBtn(false);
        mediaPlayer = new MediaPlayer();
        try {
            mediaPlayer.reset();
            mediaPlayer.setDataSource(info.getAudioUrl());
            mediaPlayer.prepareAsync();
            mediaPlayer.setOnPreparedListener(new MediaPlayer.OnPreparedListener() {
                @Override
                public void onPrepared(MediaPlayer mp) {
                    showPlayBtn(true);
                }
            });

            mediaPlayer.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
                @Override
                public void onCompletion(MediaPlayer mp) {
                    playBinding.btnPlay.setSelected(false);
                }
            });
        } catch (IOException ioException) {
            showPlayBtn(true);
        }
    }

    private void showPlayBtn(boolean showBtn) {
        if (showBtn) {
            playBinding.btnPlay.setVisibility(View.VISIBLE);
            playBinding.playLoading.setVisibility(View.GONE);
        } else {
            playBinding.btnPlay.setVisibility(View.GONE);
            playBinding.playLoading.setVisibility(View.VISIBLE);
        }
    }


    @Override
    public void onClick(View v) {
        if (v.equals(playBinding.back)) {
            finish();
        } else if (v.equals(playBinding.btnPlay)) {
            boolean selected = playBinding.btnPlay.isSelected();
            if (selected) {
                if (mediaPlayer.isPlaying()) {
                    mediaPlayer.pause();
                }
            } else {
                if (!mediaPlayer.isPlaying()) {
                    mediaPlayer.start();
                }
            }
            playBinding.btnPlay.setSelected(!selected);

        } else if (v.equals(playBinding.imLike)) {
            playBinding.imLike.setSelected(!playBinding.imLike.isSelected());
            boolean selected = playBinding.imLike.isSelected();
            if (selected) {
                info.setColorIndex(color);
                Db.addLike(info);
            } else {
                Db.removeLike(info);
            }
        } else if (v.equals(playBinding.imLoop)) {
            playBinding.imLoop.setSelected(!playBinding.imLoop.isSelected());
            mediaPlayer.setLooping(playBinding.imLoop.isSelected());
        } else if (v.equals(playBinding.imTimer)) {
            if (dialogTimer == null) {
                dialogTimer = new DialogTimer(PlaySoundsAct.this, this);
            }
            dialogTimer.showTop(playBinding.imTimer);
        }

    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (mediaPlayer.isPlaying()) {
            mediaPlayer.stop();
        }
        mediaPlayer.release();
        mediaPlayer = null;
        stopCountDown();
    }

    @Override
    public void onClickTimerListener(long time) {
        dialogTimer.hide();
        if (time == -1) {
            stopCountDown();
        } else {
            startCountDown(time);
        }

    }

    @Override
    public void onClickSoundsListener(Info data) {
        Intent intent = new Intent(this, PlaySoundsAct.class);
        intent.putExtra(MyUtils.KEY_PLAY_DATA, data);
        startActivity(intent);
        finish();
    }
}